/***************************************************************************
 *   Copyright (C) 2005 by Nicola Di Mauro                                 *
 *   ndm@di.uniba.it                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _CELLALP_H
#define _CELLALP_H

template <class T> class Cella
  {
  public:
    typedef T tipoelem;
    Cella();
    Cella(tipoelem);
    void setElemento(tipoelem);
    tipoelem getElemento() const;
    void setSucc(Cella*);
    Cella* getSucc() const;
    void setPrec(Cella*);
    Cella* getPrec() const;
    bool operator ==(Cella);
    bool operator <=(Cella);
  private:
    tipoelem elemento;
    Cella* prec;
    Cella* succ;
  };

// Implementazione della classe CellaLista
// --------------------------------------

// costruttori
template <class T> Cella<T>::Cella()
{}

template <class T> Cella<T>::Cella(tipoelem e)
{
  elemento = e;
}

template <class T> void Cella<T>::setElemento(tipoelem label)
{
  elemento = label;
}

template <class T>  T Cella<T>::getElemento() const
{
    return elemento;
}

template <class T> void Cella<T>::setSucc(Cella* p)
{
  succ=p;
}

template <class T> Cella<T>* Cella<T>::getSucc() const
  {
    return succ;
  }

template <class T> void Cella<T>::setPrec(Cella* p)
{
  prec=p;
}

template <class T> Cella<T>* Cella<T>::getPrec() const
  {
    return prec;
  }

// sovraccarico dell'operatore ==
template <class T> bool Cella<T>::operator<=(Cella cella)
{
  return (getElemento <= cella.getElemento);
}


#endif // _CELLALP_H
